var NAVTREE =
[
  [ "StdAir", "index.html", [
    [ "StdAir Documentation", "index.html", [
      [ "Getting Started", "index.html#getting_started", null ],
      [ "StdAir at SourceForge", "index.html#at_sourceforge", null ],
      [ "StdAir Development", "index.html#development", null ],
      [ "External Libraries", "index.html#external_libs", null ],
      [ "Support StdAir", "index.html#social_sponsorship", null ],
      [ "About StdAir", "index.html#about", null ]
    ] ],
    [ "BomAbstract", "a00002.html", null ],
    [ "C++ Utility Class Browsing and Dumping the StdAir BOM Tree", "a00004.html", null ],
    [ "KeyAbstract", "a00006.html", null ],
    [ "C++ Class Building Sample StdAir BOM Trees", "a00008.html", null ],
    [ "C++ Class Storing the StdAir Context", "a00010.html", null ],
    [ "People", "a00012.html", [
      [ "Project Admins (and Developers)", "a00012.html#admins", null ],
      [ "Retired Developers", "a00012.html#retired", null ],
      [ "Contributors", "a00012.html#contributors", null ],
      [ "Distribution Maintainers", "a00012.html#distributors", null ]
    ] ],
    [ "Coding Rules", "a00014.html", [
      [ "Default Naming Rules for Variables", "a00014.html#cr_variables", null ],
      [ "Default Naming Rules for Functions", "a00014.html#cr_functions", null ],
      [ "Default Naming Rules for Classes and Structures", "a00014.html#cr_classes", null ],
      [ "Default Naming Rules for Files", "a00014.html#cr_files", null ],
      [ "Default Functionality of Classes", "a00014.html#cr_classes_functionality", null ]
    ] ],
    [ "Copyright and License", "a00016.html", [
      [ "GNU LESSER GENERAL PUBLIC LICENSE", "a00016.html#gnugpl", [
        [ "Version 2.1, February 1999", "a00016.html#version", null ]
      ] ],
      [ "Preamble", "a00016.html#preamble", null ],
      [ "TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION", "a00016.html#terms", [
        [ "NO WARRANTY", "a00016.html#nowarranty", null ],
        [ "END OF TERMS AND CONDITIONS", "a00016.html#endofterms", null ]
      ] ],
      [ "How to Apply These Terms to Your New Programs", "a00016.html#howtoapply", null ]
    ] ],
    [ "Documentation Rules", "a00018.html", [
      [ "General Rules", "a00018.html#doc_general", null ],
      [ "File Header", "a00018.html#doc_header", null ],
      [ "Grouping Various Parts", "a00018.html#doc_groups", null ]
    ] ],
    [ "Main features", "a00020.html", [
      [ "Standard Airline IT Business Object Model (BOM)", "a00020.html#airline_it_bom", null ],
      [ "Architecture of the StdAir library", "a00020.html#architecture", null ]
    ] ],
    [ "Make a Difference", "a00022.html", null ],
    [ "Make a new release", "a00024.html", [
      [ "Introduction", "a00024.html#description", null ],
      [ "Initialisation", "a00024.html#initialisation", null ],
      [ "Branch creation", "a00024.html#branch_creation", null ],
      [ "Commit and publish the release branch", "a00024.html#branch_publish", null ],
      [ "Update the change-log in the trunk as well", "a00024.html#trunk_update", null ],
      [ "Create distribution packages", "a00024.html#create_packages", null ],
      [ "Generation the RPM packages", "a00024.html#generate_rpm_packages", null ],
      [ "Update distributed change log", "a00024.html#update_changelog", null ],
      [ "Create the binary package, including the documentation", "a00024.html#create_bin_packages", null ],
      [ "Upload the files to SourceForge", "a00024.html#upload_files", null ],
      [ "Upload the documentation to SourceForge", "a00024.html#upload_doc", null ],
      [ "Make a new post", "a00024.html#post_news", null ],
      [ "Send an email on the announcement mailing-list", "a00024.html#send_announce", null ]
    ] ],
    [ "Installation", "a00026.html", [
      [ "Table of Contents", "a00026.html#toc", null ],
      [ "Fedora/RedHat Linux distributions", "a00026.html#rpm_linux", null ],
      [ "StdAir Requirements", "a00026.html#requirements", null ],
      [ "Basic Installation", "a00026.html#basic_instructions", null ],
      [ "Compilers and Options", "a00026.html#compilers", null ],
      [ "Compiling For Multiple Architectures", "a00026.html#compiling_for_multi_arch", null ],
      [ "Installation Names", "a00026.html#installation_names", null ],
      [ "Optional Features", "a00026.html#optional_features", null ],
      [ "Particular systems", "a00026.html#particular_systems", null ],
      [ "Specifying the System Type", "a00026.html#specifying_system_type", null ],
      [ "Sharing Defaults", "a00026.html#sharing_defaults", null ],
      [ "Defining Variables", "a00026.html#defining_variables", null ],
      [ "`cmake' Invocation", "a00026.html#cmake_invocation", null ]
    ] ],
    [ "Linking with StdAir", "a00028.html", [
      [ "Introduction", "a00028.html#intro", null ],
      [ "Using the pkg-config command", "a00028.html#pkgconfig", null ],
      [ "Using the stdair-config script", "a00028.html#stdair_config", null ],
      [ "M4 macro for the GNU Autotools", "a00028.html#autotools", null ],
      [ "Using StdAir with dynamic linking", "a00028.html#dynamiclinking", null ]
    ] ],
    [ "Test Rules", "a00030.html", [
      [ "The Test Source Files", "a00030.html#test_source", null ],
      [ "The Reference File", "a00030.html#reference_file", null ],
      [ "Testing StdAir Library", "a00030.html#testing_using_make", null ]
    ] ],
    [ "Users Guide", "a00032.html", [
      [ "Table of Contents", "a00032.html#ug_toc", null ],
      [ "Introduction", "a00032.html#ug_introduction", null ],
      [ "Get Started", "a00032.html#ug_get_started", [
        [ "Get the StdAir library", "a00032.html#ug_get_source", null ],
        [ "Build the StdAir project", "a00032.html#ug_build_binaries", null ],
        [ "Build and Run the Tests", "a00032.html#ug_build_and_run_tests", null ],
        [ "Install the StdAir Project (Binaries, Documentation)", "a00032.html#ug_install_project", null ]
      ] ],
      [ "Exploring the Predefined BOM Tree", "a00032.html#ug_bom_tree", [
        [ "Airline Distribution BOM Tree", "a00032.html#ug_bom_distribution", null ],
        [ "Airline Network BOM Tree", "a00032.html#ug_bom_schedule", null ],
        [ "Airline Inventory BOM Tree", "a00032.html#ug_bom_inventory", [
          [ "Airline Inventory Marketing BOM Tree", "a00032.html#ug_bom_segment_branch", null ],
          [ "Airline Inventory Operating BOM Tree", "a00032.html#ug_bom_leg_branch", null ]
        ] ]
      ] ],
      [ "Extending the BOM Tree", "a00032.html#ug_extending_bom_tree", null ]
    ] ],
    [ "Supported Systems", "a00034.html", [
      [ "StdAir 3.10.x", "a00034.html#stdair_3_10", [
        [ "Linux Systems", "a00034.html#linux", [
          [ "Fedora Core 4 with ATLAS", "a00034.html#fedora_atlas", null ],
          [ "Gentoo Linux with ACML", "a00034.html#gentoo_acml", null ],
          [ "Gentoo Linux with ATLAS", "a00034.html#gentoo_atlas", null ],
          [ "Gentoo Linux with MKL", "a00034.html#gentoo_mkl", null ],
          [ "Gentoo Linux with NetLib's BLAS and LAPACK", "a00034.html#gentoo_netlib", null ],
          [ "Red Hat Enterprise Linux with StdAir External", "a00034.html#rhel", null ],
          [ "SUSE Linux 10.0 with NetLib's BLAS and LAPACK", "a00034.html#suse_netlib", null ],
          [ "SUSE Linux 10.0 with MKL", "a00034.html#suse_mkl", null ]
        ] ],
        [ "Windows Systems", "a00034.html#windows", [
          [ "Microsoft Windows XP with Cygwin", "a00034.html#cygwin", null ],
          [ "Microsoft Windows XP with Cygwin and ATLAS", "a00034.html#cygwin_atlas", null ],
          [ "Microsoft Windows XP with Cygwin and ACML", "a00034.html#cygwin_acml", null ],
          [ "Microsoft Windows XP with MinGW, MSYS and ACML", "a00034.html#mingw_acml", null ],
          [ "Microsoft Windows XP with MinGW, MSYS and StdAir External", "a00034.html#mingw_netlib", null ],
          [ "Microsoft Windows XP with MS Visual C++ and Intel MKL", "a00034.html#msvc_mkl", null ]
        ] ],
        [ "Unix Systems", "a00034.html#unix", [
          [ "SunOS 5.9 with StdAir External", "a00034.html#sunos59", null ]
        ] ]
      ] ]
    ] ],
    [ "StdAir Supported Systems (Previous Releases)", "a00036.html", [
      [ "StdAir 3.9.1", "a00036.html#stdair_3_9_1", null ],
      [ "StdAir 3.9.0", "a00036.html#stdair_3_9_0", null ],
      [ "StdAir 3.8.1", "a00036.html#stdair_3_8_1", null ]
    ] ],
    [ "Tutorials", "a00038.html", [
      [ "Table of Contents", "a00038.html#tut_toc", null ],
      [ "Introduction", "a00038.html#tut_introduction", [
        [ "Preparing the StdAir Project for Development", "a00038.html#tut_intro_configuration", null ]
      ] ],
      [ "Build a Predefined BOM Tree", "a00038.html#tut_build_bom_tree", [
        [ "Instanciate the BOM Root Object", "a00038.html#tut_build_bom_root", null ],
        [ "Instanciate the (Airline) Inventory Object", "a00038.html#tut_build_inventory", null ],
        [ "Link the Inventory Object with the BOM Root", "a00038.html#tut_build_link", null ],
        [ "Build Another Airline Inventory", "a00038.html#tut_build_inventory_another", null ],
        [ "Dump The BOM Tree Content", "a00038.html#tut_dump_bom_tree", null ],
        [ "Result of the Tutorial Program", "a00038.html#tut_result_output", null ]
      ] ],
      [ "Extend the Pre-Defined BOM Tree", "a00038.html#tut_extend_bom_tree", [
        [ "Extend an Airline Inventory Object", "a00038.html#tut_extend_inventory", null ],
        [ "Build the Specific BOM Objects", "a00038.html#tut_extend_build", null ],
        [ "Result of the Tutorial Program", "a00038.html#tut_extend_result_output", null ]
      ] ]
    ] ],
    [ "Command-Line Utility to Demonstrate Typical StdAir Usage", "a00040.html", null ],
    [ "Specific Implementation of a BOM Root", "a00042.html", null ],
    [ "Specific Implementation of a BOM Root", "a00044.html", null ],
    [ "Specific Implementation of an Airline Inventory", "a00046.html", null ],
    [ "Specific Implementation of an Airline Inventory", "a00048.html", null ],
    [ "Command-Line Test to Demonstrate How To Extend StdAir BOM", "a00050.html", null ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", "namespacemembers_dup" ],
        [ "Functions", "namespacemembers_func.html", null ],
        [ "Variables", "namespacemembers_vars.html", null ],
        [ "Typedefs", "namespacemembers_type.html", "namespacemembers_type" ],
        [ "Enumerations", "namespacemembers_enum.html", null ],
        [ "Enumerator", "namespacemembers_eval.html", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", null ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", null ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", null ],
        [ "Functions", "globals_func.html", null ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Macros", "globals_defs.html", null ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"a00002.html",
"a00058.html",
"a00077.html#a5ea59a9ff9863dc570d92e960414fed0",
"a00100.html",
"a00122.html#ac2bbbadbccaf2e36d2033e73c8cc6dc6",
"a00141.html#a4e9cc6f20637446d2967edf912bceea3",
"a00162.html#a155fc4d802684890058173ca5d6480f5",
"a00176.html#aac3c91aae4bd1a8ae2635d34b39a1036",
"a00189.html#ae24974886ceedb779c10eab04d8e13e0",
"a00205.html#a0160e5b0c91dcc303a8fcf089b5b818f",
"a00238.html#a6e3497a44011f8e98f21449897825897",
"a00246_source.html",
"a00343_source.html",
"a00436.html",
"a00517.html",
"a00545.html"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function hashValue()
{
  return $(location).attr('hash').substring(1).replace(/[^\w\-]/g,'');
}

function hashUrl()
{
  return '#'+hashValue();
}

function pathName()
{
  return $(location).attr('pathname').replace(/[^-A-Za-z0-9+&@#/%?=~_|!:,.;\(\)]/g, '');
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  }
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  var ancParent = $(anchor.parent());
  if (ancParent.hasClass('memItemLeft') ||
      ancParent.hasClass('fieldname') ||
      ancParent.hasClass('fieldtype') ||
      ancParent.is(':header'))
  {
    pos = ancParent.position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath(pathName());
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = hashUrl();
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+hashValue()+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parent().attr('class')=='fieldname'){
    glowEffect(anchor.parent().parent(),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath(pathName())+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1].replace(/[^\w\-]/g,'');
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2(pathName())+hashUrl());
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,hashUrl(),relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath(pathName())+':'+hashValue();
         a=$('.item a[class$="'+clslink.replace(/</g,'\\3c ')+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2(pathName());
       navTo(o,link,hashUrl(),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,hashUrl(),relpath);
     }
  })
}

